﻿using NathanMcRae;
using System.Text;

{
  string testName = "Bool test";
  string testString1 = "column1:ty\\#pe:boolean\tcolumn2:binary\tcolumnthree\\nyep:string" +
    "\nTRUE\tvalue\\\\t\0woo\tvaluetrhee" +
    "\nFALSE\tnother\tno\\ther";

  SaneTsv parsed = SaneTsv.ParseTypedTsv(Encoding.UTF8.GetBytes(testString1));
  if (parsed.Records[0]["column1:ty#pe"] is bool result && result)
  {
    Console.WriteLine($"Passed {testName}");
  }
  else
  {
    Console.WriteLine($"Failed {testName}");
  }
}

{
  string testName = "Bad bool test";
  try
  {
    string testString1 = "column1:type:boolean\tcolumn2:binary\tcolumnthree\\nyep:string" +
      "\nTUE\tvalue\\\\t\0woo\tvaluetrhee" +
      "\nFALSE\tnother\tno\\ther";

    SaneTsv parsed = SaneTsv.ParseTypedTsv(Encoding.UTF8.GetBytes(testString1));
    Console.WriteLine($"Failed {testName}");
  }
  catch (Exception)
  {
    Console.WriteLine($"Passed {testName}");
  }

  Console.WriteLine("Done with tests");
}
